<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQueryTransactionParameter ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQueryTransactionParameter
 * @subpackage Arrays
 */
class ArrayOfQueryTransactionParameter extends AbstractStructArrayBase
{
    /**
     * The QueryTransactionParameter
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QueryTransactionParameter[]
     */
    public $QueryTransactionParameter;
    /**
     * Constructor method for ArrayOfQueryTransactionParameter
     * @uses ArrayOfQueryTransactionParameter::setQueryTransactionParameter()
     * @param \StructType\QueryTransactionParameter[] $queryTransactionParameter
     */
    public function __construct(array $queryTransactionParameter = array())
    {
        $this
            ->setQueryTransactionParameter($queryTransactionParameter);
    }
    /**
     * Get QueryTransactionParameter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QueryTransactionParameter[]|null
     */
    public function getQueryTransactionParameter()
    {
        return isset($this->QueryTransactionParameter) ? $this->QueryTransactionParameter : null;
    }
    /**
     * Set QueryTransactionParameter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QueryTransactionParameter[] $queryTransactionParameter
     * @return \ArrayType\ArrayOfQueryTransactionParameter
     */
    public function setQueryTransactionParameter(array $queryTransactionParameter = array())
    {
        foreach ($queryTransactionParameter as $arrayOfQueryTransactionParameterQueryTransactionParameterItem) {
            // validation for constraint: itemType
            if (!$arrayOfQueryTransactionParameterQueryTransactionParameterItem instanceof \StructType\QueryTransactionParameter) {
                throw new \InvalidArgumentException(sprintf('The QueryTransactionParameter property can only contain items of \StructType\QueryTransactionParameter, "%s" given', is_object($arrayOfQueryTransactionParameterQueryTransactionParameterItem) ? get_class($arrayOfQueryTransactionParameterQueryTransactionParameterItem) : gettype($arrayOfQueryTransactionParameterQueryTransactionParameterItem)), __LINE__);
            }
        }
        if (is_null($queryTransactionParameter) || (is_array($queryTransactionParameter) && empty($queryTransactionParameter))) {
            unset($this->QueryTransactionParameter);
        } else {
            $this->QueryTransactionParameter = $queryTransactionParameter;
        }
        return $this;
    }
    /**
     * Add item to QueryTransactionParameter value
     * @throws \InvalidArgumentException
     * @param \StructType\QueryTransactionParameter $item
     * @return \ArrayType\ArrayOfQueryTransactionParameter
     */
    public function addToQueryTransactionParameter(\StructType\QueryTransactionParameter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QueryTransactionParameter) {
            throw new \InvalidArgumentException(sprintf('The QueryTransactionParameter property can only contain items of \StructType\QueryTransactionParameter, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->QueryTransactionParameter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QueryTransactionParameter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QueryTransactionParameter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QueryTransactionParameter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QueryTransactionParameter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QueryTransactionParameter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QueryTransactionParameter
     */
    public function getAttributeName()
    {
        return 'QueryTransactionParameter';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQueryTransactionParameter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
