<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransactionDetailX ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransactionDetailX
 * @subpackage Arrays
 */
class ArrayOfTransactionDetailX extends AbstractStructArrayBase
{
    /**
     * The TransactionDetailX
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionDetailX[]
     */
    public $TransactionDetailX;
    /**
     * Constructor method for ArrayOfTransactionDetailX
     * @uses ArrayOfTransactionDetailX::setTransactionDetailX()
     * @param \StructType\TransactionDetailX[] $transactionDetailX
     */
    public function __construct(array $transactionDetailX = array())
    {
        $this
            ->setTransactionDetailX($transactionDetailX);
    }
    /**
     * Get TransactionDetailX value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionDetailX[]|null
     */
    public function getTransactionDetailX()
    {
        return isset($this->TransactionDetailX) ? $this->TransactionDetailX : null;
    }
    /**
     * Set TransactionDetailX value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TransactionDetailX[] $transactionDetailX
     * @return \ArrayType\ArrayOfTransactionDetailX
     */
    public function setTransactionDetailX(array $transactionDetailX = array())
    {
        foreach ($transactionDetailX as $arrayOfTransactionDetailXTransactionDetailXItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransactionDetailXTransactionDetailXItem instanceof \StructType\TransactionDetailX) {
                throw new \InvalidArgumentException(sprintf('The TransactionDetailX property can only contain items of \StructType\TransactionDetailX, "%s" given', is_object($arrayOfTransactionDetailXTransactionDetailXItem) ? get_class($arrayOfTransactionDetailXTransactionDetailXItem) : gettype($arrayOfTransactionDetailXTransactionDetailXItem)), __LINE__);
            }
        }
        if (is_null($transactionDetailX) || (is_array($transactionDetailX) && empty($transactionDetailX))) {
            unset($this->TransactionDetailX);
        } else {
            $this->TransactionDetailX = $transactionDetailX;
        }
        return $this;
    }
    /**
     * Add item to TransactionDetailX value
     * @throws \InvalidArgumentException
     * @param \StructType\TransactionDetailX $item
     * @return \ArrayType\ArrayOfTransactionDetailX
     */
    public function addToTransactionDetailX(\StructType\TransactionDetailX $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransactionDetailX) {
            throw new \InvalidArgumentException(sprintf('The TransactionDetailX property can only contain items of \StructType\TransactionDetailX, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TransactionDetailX[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TransactionDetailX|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TransactionDetailX|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TransactionDetailX|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TransactionDetailX|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TransactionDetailX|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransactionDetailX
     */
    public function getAttributeName()
    {
        return 'TransactionDetailX';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTransactionDetailX
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
