<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuthorizationResponseX StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:AuthorizationResponseX
 * @subpackage Structs
 */
class AuthorizationResponseX extends TemplateResponseX
{
    /**
     * The AccountBrand
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AccountBrand;
    /**
     * The AccountExpiry
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AccountExpiry;
    /**
     * The AccountNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AccountNumber;
    /**
     * The AccountToken
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AccountToken;
    /**
     * The Amount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Amount;
    /**
     * The ApprovalCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ApprovalCode;
    /**
     * The Balance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Balance;
    /**
     * The CardType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CardType;
    /**
     * The Fees
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Fees;
    /**
     * The MerchantAccount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MerchantAccount;
    /**
     * The OrderID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OrderID;
    /**
     * The RecurrenceID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RecurrenceID;
    /**
     * The TransactionID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for AuthorizationResponseX
     * @uses AuthorizationResponseX::setAccountBrand()
     * @uses AuthorizationResponseX::setAccountExpiry()
     * @uses AuthorizationResponseX::setAccountNumber()
     * @uses AuthorizationResponseX::setAccountToken()
     * @uses AuthorizationResponseX::setAmount()
     * @uses AuthorizationResponseX::setApprovalCode()
     * @uses AuthorizationResponseX::setBalance()
     * @uses AuthorizationResponseX::setCardType()
     * @uses AuthorizationResponseX::setFees()
     * @uses AuthorizationResponseX::setMerchantAccount()
     * @uses AuthorizationResponseX::setOrderID()
     * @uses AuthorizationResponseX::setRecurrenceID()
     * @uses AuthorizationResponseX::setTransactionID()
     * @param string $accountBrand
     * @param string $accountExpiry
     * @param string $accountNumber
     * @param string $accountToken
     * @param float $amount
     * @param string $approvalCode
     * @param float $balance
     * @param string $cardType
     * @param float $fees
     * @param string $merchantAccount
     * @param string $orderID
     * @param string $recurrenceID
     * @param string $transactionID
     */
    public function __construct($accountBrand = null, $accountExpiry = null, $accountNumber = null, $accountToken = null, $amount = null, $approvalCode = null, $balance = null, $cardType = null, $fees = null, $merchantAccount = null, $orderID = null, $recurrenceID = null, $transactionID = null)
    {
        $this
            ->setAccountBrand($accountBrand)
            ->setAccountExpiry($accountExpiry)
            ->setAccountNumber($accountNumber)
            ->setAccountToken($accountToken)
            ->setAmount($amount)
            ->setApprovalCode($approvalCode)
            ->setBalance($balance)
            ->setCardType($cardType)
            ->setFees($fees)
            ->setMerchantAccount($merchantAccount)
            ->setOrderID($orderID)
            ->setRecurrenceID($recurrenceID)
            ->setTransactionID($transactionID);
    }
    /**
     * Get AccountBrand value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAccountBrand()
    {
        return isset($this->AccountBrand) ? $this->AccountBrand : null;
    }
    /**
     * Set AccountBrand value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $accountBrand
     * @return \StructType\AuthorizationResponseX
     */
    public function setAccountBrand($accountBrand = null)
    {
        // validation for constraint: string
        if (!is_null($accountBrand) && !is_string($accountBrand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountBrand)), __LINE__);
        }
        if (is_null($accountBrand) || (is_array($accountBrand) && empty($accountBrand))) {
            unset($this->AccountBrand);
        } else {
            $this->AccountBrand = $accountBrand;
        }
        return $this;
    }
    /**
     * Get AccountExpiry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAccountExpiry()
    {
        return isset($this->AccountExpiry) ? $this->AccountExpiry : null;
    }
    /**
     * Set AccountExpiry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $accountExpiry
     * @return \StructType\AuthorizationResponseX
     */
    public function setAccountExpiry($accountExpiry = null)
    {
        // validation for constraint: string
        if (!is_null($accountExpiry) && !is_string($accountExpiry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountExpiry)), __LINE__);
        }
        if (is_null($accountExpiry) || (is_array($accountExpiry) && empty($accountExpiry))) {
            unset($this->AccountExpiry);
        } else {
            $this->AccountExpiry = $accountExpiry;
        }
        return $this;
    }
    /**
     * Get AccountNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAccountNumber()
    {
        return isset($this->AccountNumber) ? $this->AccountNumber : null;
    }
    /**
     * Set AccountNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $accountNumber
     * @return \StructType\AuthorizationResponseX
     */
    public function setAccountNumber($accountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($accountNumber) && !is_string($accountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountNumber)), __LINE__);
        }
        if (is_null($accountNumber) || (is_array($accountNumber) && empty($accountNumber))) {
            unset($this->AccountNumber);
        } else {
            $this->AccountNumber = $accountNumber;
        }
        return $this;
    }
    /**
     * Get AccountToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAccountToken()
    {
        return isset($this->AccountToken) ? $this->AccountToken : null;
    }
    /**
     * Set AccountToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $accountToken
     * @return \StructType\AuthorizationResponseX
     */
    public function setAccountToken($accountToken = null)
    {
        // validation for constraint: string
        if (!is_null($accountToken) && !is_string($accountToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountToken)), __LINE__);
        }
        if (is_null($accountToken) || (is_array($accountToken) && empty($accountToken))) {
            unset($this->AccountToken);
        } else {
            $this->AccountToken = $accountToken;
        }
        return $this;
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \StructType\AuthorizationResponseX
     */
    public function setAmount($amount = null)
    {
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get ApprovalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getApprovalCode()
    {
        return isset($this->ApprovalCode) ? $this->ApprovalCode : null;
    }
    /**
     * Set ApprovalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $approvalCode
     * @return \StructType\AuthorizationResponseX
     */
    public function setApprovalCode($approvalCode = null)
    {
        // validation for constraint: string
        if (!is_null($approvalCode) && !is_string($approvalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($approvalCode)), __LINE__);
        }
        if (is_null($approvalCode) || (is_array($approvalCode) && empty($approvalCode))) {
            unset($this->ApprovalCode);
        } else {
            $this->ApprovalCode = $approvalCode;
        }
        return $this;
    }
    /**
     * Get Balance value
     * @return float|null
     */
    public function getBalance()
    {
        return $this->Balance;
    }
    /**
     * Set Balance value
     * @param float $balance
     * @return \StructType\AuthorizationResponseX
     */
    public function setBalance($balance = null)
    {
        $this->Balance = $balance;
        return $this;
    }
    /**
     * Get CardType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCardType()
    {
        return isset($this->CardType) ? $this->CardType : null;
    }
    /**
     * Set CardType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cardType
     * @return \StructType\AuthorizationResponseX
     */
    public function setCardType($cardType = null)
    {
        // validation for constraint: string
        if (!is_null($cardType) && !is_string($cardType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cardType)), __LINE__);
        }
        if (is_null($cardType) || (is_array($cardType) && empty($cardType))) {
            unset($this->CardType);
        } else {
            $this->CardType = $cardType;
        }
        return $this;
    }
    /**
     * Get Fees value
     * @return float|null
     */
    public function getFees()
    {
        return $this->Fees;
    }
    /**
     * Set Fees value
     * @param float $fees
     * @return \StructType\AuthorizationResponseX
     */
    public function setFees($fees = null)
    {
        $this->Fees = $fees;
        return $this;
    }
    /**
     * Get MerchantAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMerchantAccount()
    {
        return isset($this->MerchantAccount) ? $this->MerchantAccount : null;
    }
    /**
     * Set MerchantAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $merchantAccount
     * @return \StructType\AuthorizationResponseX
     */
    public function setMerchantAccount($merchantAccount = null)
    {
        // validation for constraint: string
        if (!is_null($merchantAccount) && !is_string($merchantAccount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($merchantAccount)), __LINE__);
        }
        if (is_null($merchantAccount) || (is_array($merchantAccount) && empty($merchantAccount))) {
            unset($this->MerchantAccount);
        } else {
            $this->MerchantAccount = $merchantAccount;
        }
        return $this;
    }
    /**
     * Get OrderID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrderID()
    {
        return isset($this->OrderID) ? $this->OrderID : null;
    }
    /**
     * Set OrderID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orderID
     * @return \StructType\AuthorizationResponseX
     */
    public function setOrderID($orderID = null)
    {
        // validation for constraint: string
        if (!is_null($orderID) && !is_string($orderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderID)), __LINE__);
        }
        if (is_null($orderID) || (is_array($orderID) && empty($orderID))) {
            unset($this->OrderID);
        } else {
            $this->OrderID = $orderID;
        }
        return $this;
    }
    /**
     * Get RecurrenceID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRecurrenceID()
    {
        return isset($this->RecurrenceID) ? $this->RecurrenceID : null;
    }
    /**
     * Set RecurrenceID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $recurrenceID
     * @return \StructType\AuthorizationResponseX
     */
    public function setRecurrenceID($recurrenceID = null)
    {
        // validation for constraint: string
        if (!is_null($recurrenceID) && !is_string($recurrenceID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($recurrenceID)), __LINE__);
        }
        if (is_null($recurrenceID) || (is_array($recurrenceID) && empty($recurrenceID))) {
            unset($this->RecurrenceID);
        } else {
            $this->RecurrenceID = $recurrenceID;
        }
        return $this;
    }
    /**
     * Get TransactionID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransactionID()
    {
        return isset($this->TransactionID) ? $this->TransactionID : null;
    }
    /**
     * Set TransactionID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transactionID
     * @return \StructType\AuthorizationResponseX
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($transactionID)), __LINE__);
        }
        if (is_null($transactionID) || (is_array($transactionID) && empty($transactionID))) {
            unset($this->TransactionID);
        } else {
            $this->TransactionID = $transactionID;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AuthorizationResponseX
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
