<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmvIssuerActionCode StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:EmvIssuerActionCode
 * @subpackage Structs
 */
class EmvIssuerActionCode extends AbstractStructBase
{
    /**
     * The Default
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Default;
    /**
     * The Denial
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Denial;
    /**
     * The Online
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Online;
    /**
     * Constructor method for EmvIssuerActionCode
     * @uses EmvIssuerActionCode::setDefault()
     * @uses EmvIssuerActionCode::setDenial()
     * @uses EmvIssuerActionCode::setOnline()
     * @param string $default
     * @param string $denial
     * @param string $online
     */
    public function __construct($default = null, $denial = null, $online = null)
    {
        $this
            ->setDefault($default)
            ->setDenial($denial)
            ->setOnline($online);
    }
    /**
     * Get Default value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDefault()
    {
        return isset($this->Default) ? $this->Default : null;
    }
    /**
     * Set Default value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $default
     * @return \StructType\EmvIssuerActionCode
     */
    public function setDefault($default = null)
    {
        // validation for constraint: string
        if (!is_null($default) && !is_string($default)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($default)), __LINE__);
        }
        if (is_null($default) || (is_array($default) && empty($default))) {
            unset($this->Default);
        } else {
            $this->Default = $default;
        }
        return $this;
    }
    /**
     * Get Denial value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDenial()
    {
        return isset($this->Denial) ? $this->Denial : null;
    }
    /**
     * Set Denial value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $denial
     * @return \StructType\EmvIssuerActionCode
     */
    public function setDenial($denial = null)
    {
        // validation for constraint: string
        if (!is_null($denial) && !is_string($denial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($denial)), __LINE__);
        }
        if (is_null($denial) || (is_array($denial) && empty($denial))) {
            unset($this->Denial);
        } else {
            $this->Denial = $denial;
        }
        return $this;
    }
    /**
     * Get Online value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOnline()
    {
        return isset($this->Online) ? $this->Online : null;
    }
    /**
     * Set Online value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $online
     * @return \StructType\EmvIssuerActionCode
     */
    public function setOnline($online = null)
    {
        // validation for constraint: string
        if (!is_null($online) && !is_string($online)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($online)), __LINE__);
        }
        if (is_null($online) || (is_array($online) && empty($online))) {
            unset($this->Online);
        } else {
            $this->Online = $online;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EmvIssuerActionCode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
