<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for QueryTransactionResponseX StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:QueryTransactionResponseX
 * @subpackage Structs
 */
class QueryTransactionResponseX extends TemplateResponseX
{
    /**
     * The Account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionAccountX
     */
    public $Account;
    /**
     * The Customer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionCustomerX
     */
    public $Customer;
    /**
     * The Details
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfTransactionDetailX
     */
    public $Details;
    /**
     * The FraudStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DataX
     */
    public $FraudStatus;
    /**
     * The Parameters
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfQueryTransactionParameter
     */
    public $Parameters;
    /**
     * The Payer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionPayerX
     */
    public $Payer;
    /**
     * The Recurrence
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RecurrenceInfoX
     */
    public $Recurrence;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DataX
     */
    public $Status;
    /**
     * The StatusX
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionProcessingStatus
     */
    public $StatusX;
    /**
     * The Transaction
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionMasterX
     */
    public $Transaction;
    /**
     * The Usage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DataX
     */
    public $Usage;
    /**
     * The WalletProvider
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DataX
     */
    public $WalletProvider;
    /**
     * Constructor method for QueryTransactionResponseX
     * @uses QueryTransactionResponseX::setAccount()
     * @uses QueryTransactionResponseX::setCustomer()
     * @uses QueryTransactionResponseX::setDetails()
     * @uses QueryTransactionResponseX::setFraudStatus()
     * @uses QueryTransactionResponseX::setParameters()
     * @uses QueryTransactionResponseX::setPayer()
     * @uses QueryTransactionResponseX::setRecurrence()
     * @uses QueryTransactionResponseX::setStatus()
     * @uses QueryTransactionResponseX::setStatusX()
     * @uses QueryTransactionResponseX::setTransaction()
     * @uses QueryTransactionResponseX::setUsage()
     * @uses QueryTransactionResponseX::setWalletProvider()
     * @param \StructType\TransactionAccountX $account
     * @param \StructType\TransactionCustomerX $customer
     * @param \ArrayType\ArrayOfTransactionDetailX $details
     * @param \StructType\DataX $fraudStatus
     * @param \ArrayType\ArrayOfQueryTransactionParameter $parameters
     * @param \StructType\TransactionPayerX $payer
     * @param \StructType\RecurrenceInfoX $recurrence
     * @param \StructType\DataX $status
     * @param \StructType\TransactionProcessingStatus $statusX
     * @param \StructType\TransactionMasterX $transaction
     * @param \StructType\DataX $usage
     * @param \StructType\DataX $walletProvider
     */
    public function __construct(\StructType\TransactionAccountX $account = null, \StructType\TransactionCustomerX $customer = null, \ArrayType\ArrayOfTransactionDetailX $details = null, \StructType\DataX $fraudStatus = null, \ArrayType\ArrayOfQueryTransactionParameter $parameters = null, \StructType\TransactionPayerX $payer = null, \StructType\RecurrenceInfoX $recurrence = null, \StructType\DataX $status = null, \StructType\TransactionProcessingStatus $statusX = null, \StructType\TransactionMasterX $transaction = null, \StructType\DataX $usage = null, \StructType\DataX $walletProvider = null)
    {
        $this
            ->setAccount($account)
            ->setCustomer($customer)
            ->setDetails($details)
            ->setFraudStatus($fraudStatus)
            ->setParameters($parameters)
            ->setPayer($payer)
            ->setRecurrence($recurrence)
            ->setStatus($status)
            ->setStatusX($statusX)
            ->setTransaction($transaction)
            ->setUsage($usage)
            ->setWalletProvider($walletProvider);
    }
    /**
     * Get Account value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionAccountX|null
     */
    public function getAccount()
    {
        return isset($this->Account) ? $this->Account : null;
    }
    /**
     * Set Account value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransactionAccountX $account
     * @return \StructType\QueryTransactionResponseX
     */
    public function setAccount(\StructType\TransactionAccountX $account = null)
    {
        if (is_null($account) || (is_array($account) && empty($account))) {
            unset($this->Account);
        } else {
            $this->Account = $account;
        }
        return $this;
    }
    /**
     * Get Customer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionCustomerX|null
     */
    public function getCustomer()
    {
        return isset($this->Customer) ? $this->Customer : null;
    }
    /**
     * Set Customer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransactionCustomerX $customer
     * @return \StructType\QueryTransactionResponseX
     */
    public function setCustomer(\StructType\TransactionCustomerX $customer = null)
    {
        if (is_null($customer) || (is_array($customer) && empty($customer))) {
            unset($this->Customer);
        } else {
            $this->Customer = $customer;
        }
        return $this;
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfTransactionDetailX|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfTransactionDetailX $details
     * @return \StructType\QueryTransactionResponseX
     */
    public function setDetails(\ArrayType\ArrayOfTransactionDetailX $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Get FraudStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DataX|null
     */
    public function getFraudStatus()
    {
        return isset($this->FraudStatus) ? $this->FraudStatus : null;
    }
    /**
     * Set FraudStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DataX $fraudStatus
     * @return \StructType\QueryTransactionResponseX
     */
    public function setFraudStatus(\StructType\DataX $fraudStatus = null)
    {
        if (is_null($fraudStatus) || (is_array($fraudStatus) && empty($fraudStatus))) {
            unset($this->FraudStatus);
        } else {
            $this->FraudStatus = $fraudStatus;
        }
        return $this;
    }
    /**
     * Get Parameters value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfQueryTransactionParameter|null
     */
    public function getParameters()
    {
        return isset($this->Parameters) ? $this->Parameters : null;
    }
    /**
     * Set Parameters value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfQueryTransactionParameter $parameters
     * @return \StructType\QueryTransactionResponseX
     */
    public function setParameters(\ArrayType\ArrayOfQueryTransactionParameter $parameters = null)
    {
        if (is_null($parameters) || (is_array($parameters) && empty($parameters))) {
            unset($this->Parameters);
        } else {
            $this->Parameters = $parameters;
        }
        return $this;
    }
    /**
     * Get Payer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionPayerX|null
     */
    public function getPayer()
    {
        return isset($this->Payer) ? $this->Payer : null;
    }
    /**
     * Set Payer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransactionPayerX $payer
     * @return \StructType\QueryTransactionResponseX
     */
    public function setPayer(\StructType\TransactionPayerX $payer = null)
    {
        if (is_null($payer) || (is_array($payer) && empty($payer))) {
            unset($this->Payer);
        } else {
            $this->Payer = $payer;
        }
        return $this;
    }
    /**
     * Get Recurrence value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RecurrenceInfoX|null
     */
    public function getRecurrence()
    {
        return isset($this->Recurrence) ? $this->Recurrence : null;
    }
    /**
     * Set Recurrence value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\RecurrenceInfoX $recurrence
     * @return \StructType\QueryTransactionResponseX
     */
    public function setRecurrence(\StructType\RecurrenceInfoX $recurrence = null)
    {
        if (is_null($recurrence) || (is_array($recurrence) && empty($recurrence))) {
            unset($this->Recurrence);
        } else {
            $this->Recurrence = $recurrence;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DataX|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DataX $status
     * @return \StructType\QueryTransactionResponseX
     */
    public function setStatus(\StructType\DataX $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get StatusX value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionProcessingStatus|null
     */
    public function getStatusX()
    {
        return isset($this->StatusX) ? $this->StatusX : null;
    }
    /**
     * Set StatusX value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransactionProcessingStatus $statusX
     * @return \StructType\QueryTransactionResponseX
     */
    public function setStatusX(\StructType\TransactionProcessingStatus $statusX = null)
    {
        if (is_null($statusX) || (is_array($statusX) && empty($statusX))) {
            unset($this->StatusX);
        } else {
            $this->StatusX = $statusX;
        }
        return $this;
    }
    /**
     * Get Transaction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionMasterX|null
     */
    public function getTransaction()
    {
        return isset($this->Transaction) ? $this->Transaction : null;
    }
    /**
     * Set Transaction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransactionMasterX $transaction
     * @return \StructType\QueryTransactionResponseX
     */
    public function setTransaction(\StructType\TransactionMasterX $transaction = null)
    {
        if (is_null($transaction) || (is_array($transaction) && empty($transaction))) {
            unset($this->Transaction);
        } else {
            $this->Transaction = $transaction;
        }
        return $this;
    }
    /**
     * Get Usage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DataX|null
     */
    public function getUsage()
    {
        return isset($this->Usage) ? $this->Usage : null;
    }
    /**
     * Set Usage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DataX $usage
     * @return \StructType\QueryTransactionResponseX
     */
    public function setUsage(\StructType\DataX $usage = null)
    {
        if (is_null($usage) || (is_array($usage) && empty($usage))) {
            unset($this->Usage);
        } else {
            $this->Usage = $usage;
        }
        return $this;
    }
    /**
     * Get WalletProvider value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DataX|null
     */
    public function getWalletProvider()
    {
        return isset($this->WalletProvider) ? $this->WalletProvider : null;
    }
    /**
     * Set WalletProvider value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DataX $walletProvider
     * @return \StructType\QueryTransactionResponseX
     */
    public function setWalletProvider(\StructType\DataX $walletProvider = null)
    {
        if (is_null($walletProvider) || (is_array($walletProvider) && empty($walletProvider))) {
            unset($this->WalletProvider);
        } else {
            $this->WalletProvider = $walletProvider;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\QueryTransactionResponseX
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
