<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Row StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Row
 * @subpackage Structs
 */
class Row extends AbstractStructBase
{
    /**
     * The Cells
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataX
     */
    public $Cells;
    /**
     * Constructor method for Row
     * @uses Row::setCells()
     * @param \ArrayType\ArrayOfDataX $cells
     */
    public function __construct(\ArrayType\ArrayOfDataX $cells = null)
    {
        $this
            ->setCells($cells);
    }
    /**
     * Get Cells value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataX|null
     */
    public function getCells()
    {
        return isset($this->Cells) ? $this->Cells : null;
    }
    /**
     * Set Cells value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataX $cells
     * @return \StructType\Row
     */
    public function setCells(\ArrayType\ArrayOfDataX $cells = null)
    {
        if (is_null($cells) || (is_array($cells) && empty($cells))) {
            unset($this->Cells);
        } else {
            $this->Cells = $cells;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Row
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
