<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransactionDetailX StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:TransactionDetailX
 * @subpackage Structs
 */
class TransactionDetailX extends AbstractStructBase
{
    /**
     * The AdditionalInformation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AdditionalInformation;
    /**
     * The Amount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $Amount;
    /**
     * The ApprovalCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ApprovalCode;
    /**
     * The CurrencyFormat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencyFormat;
    /**
     * The Date
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The Identifier
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Identifier;
    /**
     * The Parameters
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfParameters
     */
    public $Parameters;
    /**
     * The ResponseCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ResponseCode;
    /**
     * The ResponseDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ResponseDescription;
    /**
     * The ResponseParameters
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataX
     */
    public $ResponseParameters;
    /**
     * The ResponseReference
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ResponseReference;
    /**
     * The SettlementID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SettlementID;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DataX
     */
    public $Status;
    /**
     * The TransactionReference
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TransactionReference;
    /**
     * The TransactionRequestBaseX
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionRequestBaseX
     */
    public $TransactionRequestBaseX;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DataX
     */
    public $Type;
    /**
     * Constructor method for TransactionDetailX
     * @uses TransactionDetailX::setAdditionalInformation()
     * @uses TransactionDetailX::setAmount()
     * @uses TransactionDetailX::setApprovalCode()
     * @uses TransactionDetailX::setCurrencyFormat()
     * @uses TransactionDetailX::setDate()
     * @uses TransactionDetailX::setIdentifier()
     * @uses TransactionDetailX::setParameters()
     * @uses TransactionDetailX::setResponseCode()
     * @uses TransactionDetailX::setResponseDescription()
     * @uses TransactionDetailX::setResponseParameters()
     * @uses TransactionDetailX::setResponseReference()
     * @uses TransactionDetailX::setSettlementID()
     * @uses TransactionDetailX::setStatus()
     * @uses TransactionDetailX::setTransactionReference()
     * @uses TransactionDetailX::setTransactionRequestBaseX()
     * @uses TransactionDetailX::setType()
     * @param string $additionalInformation
     * @param float $amount
     * @param string $approvalCode
     * @param string $currencyFormat
     * @param string $date
     * @param int $identifier
     * @param \ArrayType\ArrayOfParameters $parameters
     * @param string $responseCode
     * @param string $responseDescription
     * @param \ArrayType\ArrayOfDataX $responseParameters
     * @param string $responseReference
     * @param string $settlementID
     * @param \StructType\DataX $status
     * @param string $transactionReference
     * @param \StructType\TransactionRequestBaseX $transactionRequestBaseX
     * @param \StructType\DataX $type
     */
    public function __construct($additionalInformation = null, $amount = null, $approvalCode = null, $currencyFormat = null, $date = null, $identifier = null, \ArrayType\ArrayOfParameters $parameters = null, $responseCode = null, $responseDescription = null, \ArrayType\ArrayOfDataX $responseParameters = null, $responseReference = null, $settlementID = null, \StructType\DataX $status = null, $transactionReference = null, \StructType\TransactionRequestBaseX $transactionRequestBaseX = null, \StructType\DataX $type = null)
    {
        $this
            ->setAdditionalInformation($additionalInformation)
            ->setAmount($amount)
            ->setApprovalCode($approvalCode)
            ->setCurrencyFormat($currencyFormat)
            ->setDate($date)
            ->setIdentifier($identifier)
            ->setParameters($parameters)
            ->setResponseCode($responseCode)
            ->setResponseDescription($responseDescription)
            ->setResponseParameters($responseParameters)
            ->setResponseReference($responseReference)
            ->setSettlementID($settlementID)
            ->setStatus($status)
            ->setTransactionReference($transactionReference)
            ->setTransactionRequestBaseX($transactionRequestBaseX)
            ->setType($type);
    }
    /**
     * Get AdditionalInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdditionalInformation()
    {
        return isset($this->AdditionalInformation) ? $this->AdditionalInformation : null;
    }
    /**
     * Set AdditionalInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $additionalInformation
     * @return \StructType\TransactionDetailX
     */
    public function setAdditionalInformation($additionalInformation = null)
    {
        // validation for constraint: string
        if (!is_null($additionalInformation) && !is_string($additionalInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($additionalInformation)), __LINE__);
        }
        if (is_null($additionalInformation) || (is_array($additionalInformation) && empty($additionalInformation))) {
            unset($this->AdditionalInformation);
        } else {
            $this->AdditionalInformation = $additionalInformation;
        }
        return $this;
    }
    /**
     * Get Amount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getAmount()
    {
        return isset($this->Amount) ? $this->Amount : null;
    }
    /**
     * Set Amount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $amount
     * @return \StructType\TransactionDetailX
     */
    public function setAmount($amount = null)
    {
        if (is_null($amount) || (is_array($amount) && empty($amount))) {
            unset($this->Amount);
        } else {
            $this->Amount = $amount;
        }
        return $this;
    }
    /**
     * Get ApprovalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getApprovalCode()
    {
        return isset($this->ApprovalCode) ? $this->ApprovalCode : null;
    }
    /**
     * Set ApprovalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $approvalCode
     * @return \StructType\TransactionDetailX
     */
    public function setApprovalCode($approvalCode = null)
    {
        // validation for constraint: string
        if (!is_null($approvalCode) && !is_string($approvalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($approvalCode)), __LINE__);
        }
        if (is_null($approvalCode) || (is_array($approvalCode) && empty($approvalCode))) {
            unset($this->ApprovalCode);
        } else {
            $this->ApprovalCode = $approvalCode;
        }
        return $this;
    }
    /**
     * Get CurrencyFormat value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencyFormat()
    {
        return isset($this->CurrencyFormat) ? $this->CurrencyFormat : null;
    }
    /**
     * Set CurrencyFormat value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencyFormat
     * @return \StructType\TransactionDetailX
     */
    public function setCurrencyFormat($currencyFormat = null)
    {
        // validation for constraint: string
        if (!is_null($currencyFormat) && !is_string($currencyFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($currencyFormat)), __LINE__);
        }
        if (is_null($currencyFormat) || (is_array($currencyFormat) && empty($currencyFormat))) {
            unset($this->CurrencyFormat);
        } else {
            $this->CurrencyFormat = $currencyFormat;
        }
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \StructType\TransactionDetailX
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get Identifier value
     * @return int|null
     */
    public function getIdentifier()
    {
        return $this->Identifier;
    }
    /**
     * Set Identifier value
     * @param int $identifier
     * @return \StructType\TransactionDetailX
     */
    public function setIdentifier($identifier = null)
    {
        // validation for constraint: int
        if (!is_null($identifier) && !is_numeric($identifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($identifier)), __LINE__);
        }
        $this->Identifier = $identifier;
        return $this;
    }
    /**
     * Get Parameters value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfParameters|null
     */
    public function getParameters()
    {
        return isset($this->Parameters) ? $this->Parameters : null;
    }
    /**
     * Set Parameters value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfParameters $parameters
     * @return \StructType\TransactionDetailX
     */
    public function setParameters(\ArrayType\ArrayOfParameters $parameters = null)
    {
        if (is_null($parameters) || (is_array($parameters) && empty($parameters))) {
            unset($this->Parameters);
        } else {
            $this->Parameters = $parameters;
        }
        return $this;
    }
    /**
     * Get ResponseCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResponseCode()
    {
        return isset($this->ResponseCode) ? $this->ResponseCode : null;
    }
    /**
     * Set ResponseCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $responseCode
     * @return \StructType\TransactionDetailX
     */
    public function setResponseCode($responseCode = null)
    {
        // validation for constraint: string
        if (!is_null($responseCode) && !is_string($responseCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($responseCode)), __LINE__);
        }
        if (is_null($responseCode) || (is_array($responseCode) && empty($responseCode))) {
            unset($this->ResponseCode);
        } else {
            $this->ResponseCode = $responseCode;
        }
        return $this;
    }
    /**
     * Get ResponseDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResponseDescription()
    {
        return isset($this->ResponseDescription) ? $this->ResponseDescription : null;
    }
    /**
     * Set ResponseDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $responseDescription
     * @return \StructType\TransactionDetailX
     */
    public function setResponseDescription($responseDescription = null)
    {
        // validation for constraint: string
        if (!is_null($responseDescription) && !is_string($responseDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($responseDescription)), __LINE__);
        }
        if (is_null($responseDescription) || (is_array($responseDescription) && empty($responseDescription))) {
            unset($this->ResponseDescription);
        } else {
            $this->ResponseDescription = $responseDescription;
        }
        return $this;
    }
    /**
     * Get ResponseParameters value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataX|null
     */
    public function getResponseParameters()
    {
        return isset($this->ResponseParameters) ? $this->ResponseParameters : null;
    }
    /**
     * Set ResponseParameters value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataX $responseParameters
     * @return \StructType\TransactionDetailX
     */
    public function setResponseParameters(\ArrayType\ArrayOfDataX $responseParameters = null)
    {
        if (is_null($responseParameters) || (is_array($responseParameters) && empty($responseParameters))) {
            unset($this->ResponseParameters);
        } else {
            $this->ResponseParameters = $responseParameters;
        }
        return $this;
    }
    /**
     * Get ResponseReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResponseReference()
    {
        return isset($this->ResponseReference) ? $this->ResponseReference : null;
    }
    /**
     * Set ResponseReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $responseReference
     * @return \StructType\TransactionDetailX
     */
    public function setResponseReference($responseReference = null)
    {
        // validation for constraint: string
        if (!is_null($responseReference) && !is_string($responseReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($responseReference)), __LINE__);
        }
        if (is_null($responseReference) || (is_array($responseReference) && empty($responseReference))) {
            unset($this->ResponseReference);
        } else {
            $this->ResponseReference = $responseReference;
        }
        return $this;
    }
    /**
     * Get SettlementID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSettlementID()
    {
        return isset($this->SettlementID) ? $this->SettlementID : null;
    }
    /**
     * Set SettlementID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $settlementID
     * @return \StructType\TransactionDetailX
     */
    public function setSettlementID($settlementID = null)
    {
        // validation for constraint: string
        if (!is_null($settlementID) && !is_string($settlementID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($settlementID)), __LINE__);
        }
        if (is_null($settlementID) || (is_array($settlementID) && empty($settlementID))) {
            unset($this->SettlementID);
        } else {
            $this->SettlementID = $settlementID;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DataX|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DataX $status
     * @return \StructType\TransactionDetailX
     */
    public function setStatus(\StructType\DataX $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get TransactionReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransactionReference()
    {
        return isset($this->TransactionReference) ? $this->TransactionReference : null;
    }
    /**
     * Set TransactionReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transactionReference
     * @return \StructType\TransactionDetailX
     */
    public function setTransactionReference($transactionReference = null)
    {
        // validation for constraint: string
        if (!is_null($transactionReference) && !is_string($transactionReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($transactionReference)), __LINE__);
        }
        if (is_null($transactionReference) || (is_array($transactionReference) && empty($transactionReference))) {
            unset($this->TransactionReference);
        } else {
            $this->TransactionReference = $transactionReference;
        }
        return $this;
    }
    /**
     * Get TransactionRequestBaseX value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionRequestBaseX|null
     */
    public function getTransactionRequestBaseX()
    {
        return isset($this->TransactionRequestBaseX) ? $this->TransactionRequestBaseX : null;
    }
    /**
     * Set TransactionRequestBaseX value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransactionRequestBaseX $transactionRequestBaseX
     * @return \StructType\TransactionDetailX
     */
    public function setTransactionRequestBaseX(\StructType\TransactionRequestBaseX $transactionRequestBaseX = null)
    {
        if (is_null($transactionRequestBaseX) || (is_array($transactionRequestBaseX) && empty($transactionRequestBaseX))) {
            unset($this->TransactionRequestBaseX);
        } else {
            $this->TransactionRequestBaseX = $transactionRequestBaseX;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DataX|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DataX $type
     * @return \StructType\TransactionDetailX
     */
    public function setType(\StructType\DataX $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TransactionDetailX
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
